import { select,
        arc,
        tsv,
        json,
        geoPath,
        geoOrthographic,
        zoom,
        event
       } from 'd3';

import { feature } from 'topojson';

    const svg = d3.select('svg');
    const path = svg.append('path');
    const projection = d3.geoOrthographic();
    const initialScale = projection.scale();
    const geoPath = d3.geoPath().projection(projection);
    const sensitivity = 58;
    
    d3.json('world-110m.json', (error, world) => {
      const land = topojson.feature(world, world.objects.land);
      const render = () => path.attr('d', geoPath(land));
      render();
      svg
        .call(d3.drag().on('drag', () => {
          const rotate = projection.rotate();
          const k = sensitivity / projection.scale();
          projection.rotate([
            rotate[0] + d3.event.dx * k,
            rotate[1] - d3.event.dy * k
          ])
          render();
        }))
        .call(d3.zoom().on('zoom', () => {
          projection.scale(initialScale * d3.event.transform.k);
          render();
        }));
    });

// json('https://cdn.jsdelivr.net/npm/world-atlas@2/countries-110m.json')
// 	.then(data => {
// 		const countries = feature(data, data.objects.countries);
//   	g.selectAll('path')
//       .data(countries.features)
//       .enter()
//       .append('path')
//   		.attr('class','country')
//       .attr('d', pathGenerator)
//   	.append('title')
//   		.text(d => d.properties.name);
// 	});